<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.0a (rvision 42126)
#									########################
#					Dvelopp pour Thelia_multi
#						Version : 1.4.2
#						Compatibilit plateforme : V1
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						26/12/2012
#						Contact : support@payzen.eu
#
#####################################################################################################

include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsPaiements.class.php");
include_once(realpath(dirname(__FILE__)) . "/config.php");

class Vads_multi extends PluginsPaiements {
	
	function Vads_multi() {
		$this->PluginsPaiements("vads_multi");
	}
	
	function init() {
		$this->ajout_desc(
			"PayZen - Paiement multiple",
			"PayZen - Paiement multiple", 
			"Ce module permet d'effectuer des paiements scuriss en plusieurs fois via la plateforme PayZen",
			1
		);
	}

	function paiement($commande) {
		$total = $commande->total() + $commande->port - $commande->remise;
		
		header("Location: client/plugins/vads_multi/paiement.php");		
	}

	// Override PAIEMENT loop to check amount restrictions
	function boucle($texte, $args) {
		// calculate order amount
		$total = $_SESSION['navig']->panier->total(1, $_SESSION['navig']->commande->remise) + $_SESSION['navig']->commande->port;
		$total = round($total, 2);
	
		// minimum and maximum amount restrictions
		if ((defined('MODULE_PAYMENT_VADS_MULTI_AMOUNT_MIN') && MODULE_PAYMENT_VADS_MULTI_AMOUNT_MIN != '' && $total < MODULE_PAYMENT_VADS_MULTI_AMOUNT_MIN)
		|| (defined('MODULE_PAYMENT_VADS_MULTI_AMOUNT_MAX') && MODULE_PAYMENT_VADS_MULTI_AMOUNT_MAX != '' && $total > MODULE_PAYMENT_VADS_MULTI_AMOUNT_MAX)) {
				
			$args .= ' exclusion="vads_multi"'; // exclude this payment method
		}
	
		// Call standard PAIEMENT loop
		return bouclePaiement($texte, $args);
	}
	
	function mail($commande) {
		if(MODULE_PAYMENT_VADS_MULTI_SEND_MAIL_MODE == 'BEFORE') {
			parent::mail($commande);
		} else {
			// envoyer seulement un mail  l'administrateur
			$msg = new Message();
				
			/* Message admin */
			$msg->charger("mailconfirmadm");
			$msgdesc = new Messagedesc();
			$msgdesc->charger($msg->id);
			$corps2 = $msgdesc->description;
				
			$emailcontact = new Variable();
			$emailcontact->charger("emailcontact");
			$sujet2 = $this->substitmail($msgdesc->titre, $commande);
			$corps2 = $this->substitmail($corps2, $commande);
			$corpstext2 = $msgdesc->descriptiontext;
			$corpstext2 = $this->substitmail($corpstext2,$commande);
				
			$nomsite = new Variable();
			$nomsite->charger("nomsite");
				
			//envoi du mail a l'admin
			$mail = new Mail();
			$mail->IsMail();
			$mail->FromName = $nomsite->valeur;
			$mail->From = $emailcontact->valeur;
			$mail->Subject = $sujet2;
			$mail->MsgHTML($corps2);
			$mail->AltBody = $corpstext2;
			$mail->AddAddress($emailcontact->valeur,$nomsite->valeur);
				
			$mail->send();
		}
	}
	
	function mail_client($commande) {
		// si l'option "envoyer la notification aprs le paiement" est active et le paiement a russi
		if(MODULE_PAYMENT_VADS_MULTI_SEND_MAIL_MODE == 'AFTER' && $commande->statut == 2) {
			/* Message client */
			$msg = new Message();
	
			$msg->charger("mailconfirmcli");
			$msgdesc = new Messagedesc();
			$msgdesc->charger($msg->id);
			$sujet = $this->substitmail($msgdesc->titre, $commande);
	
			$corps = $msgdesc->description;
			$corps = $this->substitmail($corps, $commande);
			$corpstext = $msgdesc->descriptiontext;
			$corpstext = $this->substitmail($corpstext,$commande);
				
			$client = new Client();
			$client->charger_id($commande->client);
	
			$emailcontact = new Variable();
			$emailcontact->charger("emailcontact");
				
			$nomsite = new Variable();
			$nomsite->charger("nomsite");
	
			//envoi du mail au client
			$mailclient = new Mail();
			$mailclient->IsMail();
			$mailclient->FromName = $nomsite->valeur;
			$mailclient->From = $emailcontact->valeur;
			$mailclient->Subject = $sujet;
			$mailclient->MsgHTML($corps);
			$mailclient->AltBody = $corpstext;
			$mailclient->AddAddress($client->email,$client->nom." ".$client->prenom);
	
			$mailclient->send();
		}
	}
	
}

?>