<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.0a (rvision 42126)
#									########################
#					Dvelopp pour Thelia_multi
#						Version : 1.4.2
#						Compatibilit plateforme : V1
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						26/12/2012
#						Contact : support@payzen.eu
#
#####################################################################################################
/*
 * Page appele par la plateforme de paiement pour confirmation
 */

include_once(realpath(dirname(__FILE__)) . "/config.php");
include_once(realpath(dirname(__FILE__)) . "/vads_multi_api.php");

include_once("../../../classes/Commande.class.php");
include_once("../../../classes/Variable.class.php");
include_once("../../../fonctions/divers.php");

/*
 * Initialisation des variables
 */

// Do not use $_REQUEST because currency and language may be redefined in $_COOKIE 
if($_POST && key_exists('order_id', $_POST)) {
	$data = $_POST;
} else {
	$data = $_GET;
}

	$vad_api = new VADS_MULTI_API();
	$vad_api->setResponseFromPost(	$data,
									MODULE_PAYMENT_VADS_MULTI_KEY_TEST,
									MODULE_PAYMENT_VADS_MULTI_KEY_PROD,
									MODULE_PAYMENT_VADS_MULTI_CTX_MODE
								);
	
	$from_server = isset($data['hash']);
	
	// Urls
	$variable_loader = new Variable();
	$variable_loader->charger("urlsite");
	$urlsite = $variable_loader->valeur;
	$urlsite = (substr($urlsite,-1)=="/") ? $urlsite : $urlsite."/";
	
	$url_success = $urlsite."merci.php";
	$url_error = $urlsite."regret.php";
	$url_retry = $urlsite."commande.php";
	
	/*
	 * Vrification de l'authenticit de la requte
	 */
	if(! $vad_api->isAuthentifiedResponse()){
		if( $from_server ) {
			// Une rponse courte pour la plateforme de paiement
			die( $vad_api->getCheckUrlResponse('auth_fail') );
		}
		
		header("Location:".$url_error);
		die();
	}

// Requte authentique

/*
 * Rcupration de la commande
 */
	$commande = new Commande();
	$reference = mysql_real_escape_string($data['order_id']); // On n'est jamais trop prudent
	$commande->charger_ref($reference);

/*
 * Action selon les diffrents cas
 */
	
	if($commande->statut == 1){
		// Commande non paye
		if($vad_api->isAcceptedPayment()){
			// Paiement accept
			$commande->statut = 2;	// statut "pay"
			$commande->genfact();	// gnration facture
			$commande->maj();
			
			modules_fonction("confirmation", $commande, 'vads_multi');	// traitements supplmentaires
			modules_fonction("mail_client", $commande, 'vads_multi');
			
			// Message de confirmation
			if( $from_server ){
				// Une rponse courte pour la plateforme de paiement
				die( $vad_api->getCheckUrlResponse('payment_ok'));
			}
			// Une belle page pour le client
			if( $vad_api->get('ctx_mode')=='TEST'){
				echo '<html xmlns="http://www.w3.org/1999/xhtml">';
				echo '<head>';
				echo '<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />';
				echo '</head>';
				
				echo '<body>';
				
				echo "Avertissement mode TEST : la commande a bien &eacute;t&eacute; enregistr&eacute;e, mais la validation automatique n'a pas fonctionn&eacute;.";
				echo "<br/>V&eacute;rifiez que vous avez correctement configur&eacute; l'url serveur (".$urlsite."client/plugins/vads_multi/confirmation.php. ) ";
				echo "dans l'outil de gestion de caisse PayZen et qu'elle est accessible depuis internet";
				echo '<br/>En mode production, vous serez redirig&eacute; automatiquement vers <a href="'.$url_success.'">la page de succ&egrave;s</a>';
				
				echo '</body>';
				echo '</html>';
				exit();
			}
			header("Location:".$url_success);
			exit();
		}
		else {
			// Paiement chou => on laisse en non pay
			// Message de confirmation
			if( $from_server) {
				// Une rponse courte pour la plateforme de paiement
				die( $vad_api->getCheckUrlResponse('payment_ko') );
			}
			// Retour  la liste des moyens de paiement pour le client
			header("Location:".$url_retry);
			exit();
		}
	}
	else {
	// Commande dj paye
		if($vad_api->isAcceptedPayment()){
			// Paiement accept, dj enregistr
			if( $from_server ){
				// Une rponse courte pour la plateforme de paiement
				die( $vad_api->getCheckUrlResponse('payment_ok_already_done') );
			}
			// Une belle page pour le client
			header("Location:".$url_success);
			exit();
		}
		else {
			// Paiement chou pour une commande dj enregistre (cas anormal)
			if( $from_server) {
				// Une rponse courte pour la plateforme de paiement
				die( $vad_api->getCheckUrlResponse('payment_ko_on_order_ok') );
			}
			// Une belle page pour le client
			header("Location:".$url_error);
			exit();
		}
	}

?>